//
//  ProfileViewController.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/8/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit
import RxSwift
import RxCocoa
import RxDataSources
import RxOptional

enum ProfileCellType {
    case header(viewModel: ProfileHeaderViewModel)
    
    case divider
    
    /// More Activities
    case message
    case comment
    case level
    case createNewTransaction
    case transactionsHistory
    
    /// More info section
    case feedback
    case shareOurApp
}
protocol ProfilePresenterInterface: PresenterInterface {
    var selectedSettingsTrigger: PublishRelay<Void> { get}
    var editMembershipProfileTrigger: PublishRelay<Void> { get }
    var createTransactionTrigger: PublishRelay<Void> { get }
}

final class ProfileViewController: UIViewController, ProfileViewInterface {
    let dataPresenter = BehaviorRelay<ProfileDataPresenter?>(value: nil)
    
    // MARK: - Public properties -
    
    @IBOutlet weak private var tableView: UITableView!
    
    private let viewDidLoadRelay = BehaviorRelay(value: false)
    private lazy var dataSource = makeDataSource()
    private let disposeBag = DisposeBag()
    
    var presenter: ProfilePresenterInterface!
    
    // MARK: - Lifecycle -
    
    override func viewDidLoad() {
        super.viewDidLoad()
        defer {
            viewDidLoadRelay.accept(true)
        }
        configureViews()
        configurePresenter()
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        
        navigationItem.title = "Thông tin thành viên"
        
        let editBarButtonItem = UIBarButtonItem(title: "Chỉnh sửa", style: .plain, target: self, action: #selector(didTapEditBarButton))
        navigationItem.rightBarButtonItem  = editBarButtonItem
    }
    
    @objc func didTapEditBarButton() {
        presenter.editMembershipProfileTrigger.accept(())
    }
    
}

// MARK: - Extensions -

extension ProfileViewController {
    
    private func configureViews() {
        configureTableView()
    }
    
    private func configureTableView() {
        tableView.backgroundColor = Colors.white400
        tableView.contentInset = UIEdgeInsets(top: .zero, left: .zero, bottom: 48.0, right: .zero)
        
        tableView.register(cellType: ProfileHeaderCell.self)
        tableView.register(cellType: ProfileInfoCell.self)
        tableView.register(cellType: DividerCell.self)
        
        tableView
            .rx
            .modelSelected(ProfileCellType.self).subscribeNext { model in
                self.handleSelected(model)
            }
            .disposed(by: disposeBag)
    }
    
    private func handleSelected(_ model: ProfileCellType) {
        switch model {
        case .shareOurApp:
            break
            
        case .feedback:
            break
            
        case .createNewTransaction:
            presenter.createTransactionTrigger.accept(())
            
        default:
            break
        }
    }
    
    private func configurePresenter() {
        let didLoad = viewDidLoadRelay.asObservable()
        dataPresenter
            .filterNil()
            .takeLatestWhen(didLoad)
            .map{ [ Section(model: 0, items: $0.joined()) ] }
            .bind(to: tableView.rx.items(dataSource: dataSource))
            .disposed(by: disposeBag)
    }
}

extension ProfileViewController {
    typealias Section = SectionModel<Int, ProfileCellType>
    typealias DataSource = RxTableViewSectionedReloadDataSource<Section>
}

extension ProfileViewController {
    func makeDataSource() -> DataSource {
        return DataSource(
            configureCell: {[weak self] (_, tableView, indexPath, model) -> UITableViewCell in
                guard let self = self else {
                    fatalError("Could not initialize tableview view")
                }
                
                switch model {
                case let .header(viewModel):
                    return self.makeHeaderCell(tableView, viewModel: viewModel, for: indexPath)
                    
                case .divider:
                    let cell: DividerCell = tableView.dequeueReusableCell(for: indexPath)
                    return cell
                    
                case .message:
                    return self.makeInfoCell(
                        tableView,
                        viewModel: ProfileInfoViewModel(
                            title: "Lời nhắn",
                            icon: Asset.Icon.Common.icIosSystemMessages.image.color(Colors.ink400s)
                        ),
                        for: indexPath
                    )
                    
                case .comment:
                    return self.makeInfoCell(
                        tableView,
                        viewModel: ProfileInfoViewModel(
                            title: "my comments",
                            icon: Asset.Icon.Common.icIosSystemComments.image.color(Colors.ink400s)
                        ),
                        for: indexPath
                    )
                    
                case .level:
                    return self.makeInfoCell(
                        tableView,
                        viewModel: ProfileInfoViewModel(
                            title: "Thông tin xếp hạng",
                            icon: Asset.Icon.Common.icIosSystemLevel.image.color(Colors.ink400s)
                        ),
                        for: indexPath
                    )
                    
                case .feedback:
                    return self.makeInfoCell(
                        tableView,
                        viewModel: ProfileInfoViewModel(
                            title: "feedback",
                            icon: Asset.Icon.Common.icIosSystemFeedback.image.color(Colors.ink400s)
                        ),
                        for: indexPath
                    )
                    
                case .shareOurApp:
                    return self.makeInfoCell(
                        tableView,
                        viewModel: ProfileInfoViewModel(
                            title: "share our app",
                            icon: Asset.Icon.Common.icIosSystemShareOurApp.image.color(Colors.ink400s)
                        ),
                        for: indexPath
                    )
                    
                case .createNewTransaction:
                    return self.makeInfoCell(
                        tableView,
                        viewModel: ProfileInfoViewModel(
                            title: "Tạo mới giao dịch",
                            icon: Asset.Icon.Common.icIosSystemShareWithFriend.image.color(Colors.ink400s)
                        ),
                        for: indexPath
                    )
                    
                case .transactionsHistory:
                    return self.makeInfoCell(
                        tableView,
                        viewModel: ProfileInfoViewModel(
                            title: "Lịch sử giao dịch",
                            icon: Asset.Icon.Common.icIosSystemComments.image.color(Colors.ink400s)
                        ),
                        for: indexPath
                    )
                }
            }
        )
    }
    
    func makeHeaderCell(_ tableView: UITableView,
                        viewModel: ProfileHeaderViewModel,
                        for indexPath: IndexPath) -> UITableViewCell {
        
        let cell: ProfileHeaderCell = tableView.dequeueReusableCell(for: indexPath)
        cell.configureCell(viewModel: viewModel)
        return cell
    }
    
    func makeInfoCell(_ tableView: UITableView,
                      viewModel: ProfileInfoViewModel,
                      for indexPath: IndexPath) -> UITableViewCell {
        
        let cell: ProfileInfoCell = tableView.dequeueReusableCell(for: indexPath)
        cell.configureCell(viewModel: viewModel)
        return cell
    }
}
